<?php

	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// General Configuration Settings
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	define ( 'SITENAME',	'camsite' );						// Your Site Name
	define ( 'BASEHREF',	'http://your.domain.com/' );	// The Url path o the index.php
	define ( 'BASEPATH',	'/path/to/this/script' );			// The file directory path to index.php
	define ( 'USER',		'blogbabes' );						// Your Chaturbate Username ( this is only useful if you embed a personal chatroom )
	define ( 'AFFID',		'827SM' );							// Chaturbate Affiliate ID
	define ( 'TRACK',		'AWPWL' );							// Chaturbate Campaign for Tracking
	define ( 'MODE',		'revshare' );						// ( revshare or signup )
	define ( 'ROOM',		'top' );							// Which featured chatroom to embed ( top, male, transexual, personal, NULL )
	define ( 'CBWL',		'chaturbate.com' );					// If you are wanting to change the domain to match one of your hosted whitelabels,
																// enter the domain here. eg ( www.yourdomain.com ) the default is 'chaturbate.com'
																
	define ( 'SHOW_STATUS', true );								// Shows or hides the room status public, private  ( true or false )	
	define ( 'RELATED_SHOW',true );								// Shows related cams on single cam page.
	define ( 'RELATED_CNT', 8 );								// The amount of related cams to show.
	define ( 'PAGINATE',	false );							// Set true to use paging instead of isotope.
															
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Thumbnail Position Ads
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////	
	
	define ( 'AD_POS1',		NULL );								// ( Thumbnail Ad Position starting at 0 , NULL for no ad )
	define ( 'AD_POS2',		NULL );								// ( Thumbnail Ad Position starting at 0 , NULL for no ad )
	define ( 'AD_POS3',		NULL );								// ( Thumbnail Ad Position starting at 0 , NULL for no ad )
	define ( 'AD_POS4',		NULL );								// ( Thumbnail Ad Position starting at 0 , NULL for no ad )
	
	define ( 'AD_CODE1',	NULL );								// ( Ad Code for position 1 )
	define ( 'AD_CODE2',	NULL );								// ( Ad Code for position 2 )
	define ( 'AD_CODE3',	NULL );								// ( Ad Code for position 3 )
	define ( 'AD_CODE4',	NULL );								// ( Ad Code for position 4 )	
	
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Display Functions No Need to Edit any of this unless you really want to.
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		// Do the XML Request 
		
			function get_cams( $affid, $track, $gender, $limit ){
				
				if ( $_GET['arg1'] ) {
					
					if ( is_numeric( $_GET['arg1'] ) ) {
					
						$page = $_GET['arg1'];
						$targetpage = 'cams/';
						
					} else {
					
						$targetpage = 'cams/' . $_GET['arg1'] . '/';
					
						if ( $_GET['arg2']  ) {

							if ( is_numeric( $_GET['arg2'] ) ) {

								$page = $_GET['arg2'];
								
							} 
							
						} else {
						
							$page = 1;
						
						}
						
					} 
					
				} else {
					
					$targetpage = 'cams/';
					$page = 1;
				
				}
				
				$end 	= $page * $limit;
				$start	= $end - $limit;
				
				$xml = 'http://' . CBWL . '/affiliates/api/onlinerooms/?format=xml&wm='.$affid.'';
				
				$cams = new SimpleXMLElement($xml, null, true);
				
				// Count the total cams
				
				if ( $gender != '' ) {
				
					$doc = new DOMDocument();
					$doc->load($xml);
					$totalCams = 0;
					foreach( $doc->getElementsByTagName('gender') as $tag ) 
					{
						// to iterate the children
						foreach( $tag->childNodes as $child ) 
						{
							// outputs the xml of the child nodes. Of course, there are any number of
							// things that you could do instead!
							$i = $doc->saveXML($child);
							
							if ($i == $gender )
								$totalCams++;
						}
					}

					
				} else {
				
					$totalCams = count($cams);
					
				}
				
				if( !PAGINATE ) {
				
					echo '
						
						<section id="options">
						
							<div class="row">
							
								<div class="9u">

									<ul id="sort-by" class="option-set clearfix" data-option-key="sortBy">
										<li><a href="#sortBy=original-order" data-option-value="original-order" class="button selected">original-order</a></li>
										<li><a href="#sortBy=age" data-option-value="age" class="button">Age</a></li>
										<li><a href="#sortBy=name" data-option-value="name" class="button">Name</a></li>
										<li><a href="#sortBy=online"  data-option-value="online" class="button">Time Online</a></li>
										<li><a href="#sortBy=viewers" data-option-value="viewers" class="button">Viewers</a></li>
									</ul>	
									
								</div>
								
								<div class="3u text-right">
								
									<ul id="sort-direction" class="option-set clearfix" data-option-key="sortAscending">
										<li><a href="#sortAscending=true" data-option-value="true" class="selected button"><i class="fa fa-sort-asc"></i></a></li>
										<li><a href="#sortAscending=false" data-option-value="false" class="button"><i class="fa fa-sort-desc"></i></a></li>
									</ul>
									
								</div>
							
							</div>
							
						</section>
					';
					
				}
				
				echo '
					
					<section class="isotope">
						<div class="row">
							<div class="12u">
								<ul class="cb_thumbs">
				';
				
				$count = 0;
				
				foreach( $cams as $cam ){ 

					if ( $cam->gender == $gender ) {
						
						if ( PAGINATE ) {

							if ( $count >= $start && $count < $end ) {

								if ( $count == AD_POS1 && AD_POS1 != null || $count == AD_POS2 && AD_POS2 != null || $count == AD_POS3 && AD_POS3 != null || $count == AD_POS4 && AD_POS4 != null )
								{
								
									if ( $count == AD_POS1 ) 
										echo '<li class="element">' . AD_CODE1 . '</li>';
									if ( $count == AD_POS2 ) 
										echo '<li class="element">' . AD_CODE2 . '</li>';
									if ( $count == AD_POS3 ) 
										echo '<li class="element">' . AD_CODE3 . '</li>';							
									if ( $count == AD_POS4 ) 
										echo '<li class="element">' . AD_CODE4 . '</li>';					
									
								} else {
								
									print_cams($cam);
								
								}
							
							}
						
						} else {

							if ( $count == AD_POS1 && AD_POS1 != null || $count == AD_POS2 && AD_POS2 != null || $count == AD_POS3 && AD_POS3 != null || $count == AD_POS4 && AD_POS4 != null )
							{
							
								if ( $count == AD_POS1 ) 
									echo '<li class="element">' . AD_CODE1 . '</li>';
								if ( $count == AD_POS2 ) 
									echo '<li class="element">' . AD_CODE2 . '</li>';
								if ( $count == AD_POS3 ) 
									echo '<li class="element">' . AD_CODE3 . '</li>';							
								if ( $count == AD_POS4 ) 
									echo '<li class="element">' . AD_CODE4 . '</li>';					
									
							} else {
								
								print_cams($cam);
								
							}

						}
						
						$count++;
						
					} 
					
					if ( $gender == '' ) {
					
						if ( PAGINATE ) {

							if ( $count >= $start && $count < $end ) {
							
								if ( $count == AD_POS1 && AD_POS1 != null || $count == AD_POS2 && AD_POS2 != null || $count == AD_POS3 && AD_POS3 != null || $count == AD_POS4 && AD_POS4 != null )
								{
								
									if ( $count == AD_POS1 ) 
										echo '<li class="element">' . AD_CODE1 . '</li>';
									if ( $count == AD_POS2 ) 
										echo '<li class="element">' . AD_CODE2 . '</li>';
									if ( $count == AD_POS3 ) 
										echo '<li class="element">' . AD_CODE3 . '</li>';							
									if ( $count == AD_POS4 ) 
										echo '<li class="element">' . AD_CODE4 . '</li>';					
									
								} else {
								
									print_cams($cam);
								
								}
								
							}
							
						} else {
						
							if ( $count == AD_POS1 && AD_POS1 != null || $count == AD_POS2 && AD_POS2 != null || $count == AD_POS3 && AD_POS3 != null || $count == AD_POS4 && AD_POS4 != null )
							{
								
								if ( $count == AD_POS1 ) 
									echo '<li class="element">' . AD_CODE1 . '</li>';
								if ( $count == AD_POS2 ) 
									echo '<li class="element">' . AD_CODE2 . '</li>';
								if ( $count == AD_POS3 ) 
									echo '<li class="element">' . AD_CODE3 . '</li>';							
								if ( $count == AD_POS4 ) 
									echo '<li class="element">' . AD_CODE4 . '</li>';					
									
							} else {
								
								print_cams($cam);
								
							}						
						
						}
						
						$count++;
								
					}
					
					
				}
				
				echo '
								</ul>
							</div>
						</div>
					</section>
					
					<div class="row">
						<div class="12u">
				';
				
				if ( PAGINATE )
					paginate($page, $totalCams, $limit, $targetpage);
				
				echo '
						</div>
					</div>
				';
				
			}
			
		// Get Related Cams

			function get_related( $affid, $track, $gender, $limit ){
				
				if ( $_GET['arg1'] ) {
					
					if ( is_numeric( $_GET['arg1'] ) ) {
					
						$page = $_GET['arg1'];
						$targetpage = 'cams/';
						
					} else {
					
						$targetpage = 'cams/' . $_GET['arg1'] . '/';
					
						if ( $_GET['arg2']  ) {

							if ( is_numeric( $_GET['arg2'] ) ) {

								$page = $_GET['arg2'];
								
							} 
							
						} else {
						
							$page = 1;
						
						}
						
					} 
					
				} else {
					
					$targetpage = 'cams/';
					$page = 1;
				
				}
				
				$end 	= $page * $limit;
				$start	= $end - $limit;
				
				$xml = 'http://' . CBWL . '/affiliates/api/onlinerooms/?format=xml&wm='.$affid.'';
				
				$cams = new SimpleXMLElement($xml, null, true);
				
				// Count the total cams
				
				if ( $gender != '' ) {
				
					$doc = new DOMDocument();
					$doc->load($xml);
					$totalCams = 0;
					foreach( $doc->getElementsByTagName('gender') as $tag ) 
					{
						// to iterate the children
						foreach( $tag->childNodes as $child ) 
						{
							// outputs the xml of the child nodes. Of course, there are any number of
							// things that you could do instead!
							$i = $doc->saveXML($child);
							
							if ($i == $gender )
								$totalCams++;
						}
					}

					
				} else {
				
					$totalCams = count($cams);
					
				}
				
				echo '
					
					
					<section class="isotope">
						<div class="row">
							<div class="12u">
								<ul class="cb_thumbs">
				';
				
				$count = 0;
				
				foreach( $cams as $cam ){ 

					if ( $cam->gender == $gender ) {

						if ( $count >= $start && $count < $end ) {

							print_cams($cam);
							
						}


						$count++;
						
					} 
					
					if ( $gender == '' ) {

						if ( $count >= $start && $count < $end ) {
								print_cams($cam);
						}
						
						$count++;
								
					}
					
					
				}
				
				echo '
								</ul>
							</div>
						</div>
					</section>
					
				';
				
			}		
			
			
		// Print each individual cam
		
			function print_cams($cam) {

				switch ( $cam->gender) {
					
					case f:
						$gender = 'female';
						break;
					case m:
						$gender = 'male';
						break;
					case c:
						$gender = 'couple';
						break;
					case s:
						$gender = 'shemale';
						break;
					default:
						$gender = '';
				}			
				
				echo '
						
					<li class="element">
					
						<div class="cb_thumbnail">
							<a href="' . BASEHREF . 'cam/' . $cam->username . '" title=""><img src="' . $cam->image_url . '" alt="' . $cam->display_name . '" /></a>
							';
							
							if ( SHOW_STATUS )
								echo '<div class="cb_status ' . $cam->current_show . '">' . $cam->current_show . '</div>';
							
							echo '
						</div>

						<div class="cb_user">
							<a href="' . BASEHREF . 'cam/' . $cam->username . '" title=""><i class="fa fa-user"></i>&nbsp;<span class="name">' . limit_chars( $cam->username, 20 ) . '</span></a>
							<span class="cb_age"><span class="age">' . $cam->age . '</span> <span class="cb_gender">' . $gender . '</span></span>
						</div>
						
						<span class="online" style="display: none;">' . $cam->seconds_online . '</span>
						<div class="cb_time_online"><i class="fa fa-clock-o"></i>&nbsp;' .  ago( $cam->seconds_online ) . '</div>
						<div class="cb_num_users"><span class="viewers">' . $cam->num_users . '</span>&nbsp;<i class="fa fa-eye"></i></div>
						

					</li>
							
				';	
				
			}			
		
		// Print Solo Cams
		
			function solo_cams( $affid, $track, $user ) {
				
				$cams = new SimpleXMLElement('http://' . CBWL . '/affiliates/api/onlinerooms/?format=xml&wm='.$affid.'', null, true);
				
				foreach( $cams as $cam ){ 
				
					switch ( $cam->gender) {
						
						case f:
							$gender = 'female';
							break;
						case m:
							$gender = 'male';
							break;
						case c:
							$gender = 'couple';
							break;
						case s:
							$gender = 'shemale';
							break;
						default:
							$gender = '';
					}				


					if ( $cam->username == $user ) {
					
						echo '
						
							<div class="heading">
								<h2>' . $_GET['arg1'] . '\'s Free live Webcam Show</h2>
								<a href="http://' . CBWL . '/affiliates/in/3Mc9/' . AFFID . '/?track=' . TRACK . '" target="_blank" class="button">Register to tip ' . $_GET['arg1'] . '</a>
							</div>		
							
							<div class="row">
								<div class="9u">
									<section class="cb_video video-wrapper">
							
						';					
					
						if ( MODE == 'revshare' ) {

								$iframe = str_replace( 'chaturbate.com', CBWL, $cam->iframe_embed_revshare );
								echo $iframe;

						} else {

								$iframe = str_replace( 'chaturbate.com', CBWL, $cam->iframe_embed );
								echo $iframe;
								
						}
						
						echo '
						
									</section>
								</div>
								<div class="3u">
									<ul class="list1">		
										<li>' . $cam->age . ' ' . $gender . '</li>
										<li>' . $cam->location . '</li>
										<li><i class="fa fa-clock-o"></i>&nbsp; ' . ago( $cam->seconds_online ) . '</li>
										<li><i class="fa fa-eye"></i>&nbsp; ' . $cam->num_users . '</li>
										';
										
										if( MODE == 'revshare' ) {
											echo '<li><a href="' . $cam->chat_room_url_revshare . '" class="button">View Profile</a></li>';
										} else {
											echo '<li><a href="' . $cam->chat_room_url . '" class="button">View Profile</a></li>';
										}
										
										echo '
									</ul>
								</div>
							</div>
							

							<section>
								<p>Welcome to <strong>' . $_GET['arg1'] . '\'s live stream</strong> and chat room! Watching ' . $_GET['arg1'] . ' getting naked, fucking, sucking, etc... is <storng>completely FREE</strong>! However, to chat with ' . $_GET['arg1'] . ', view ' . $_GET['arg1'] . '\'s private profile photos and video clips, and many more member-only features... you\'ll need a <a href="http://' . CBWL . '/affiliates/in/3Mc9/' . AFFID . '/?track=' . TRACK . '">FREE account</a>. Right now, ' . $_GET['arg1'] . ' is responding live to viewers... <a href="http://' . CBWL . '/affiliates/in/3Mc9/' . AFFID . '/?track=' . TRACK . '">Create your free account</a> now to join in on the fun!</p>
							</section>

							
							
						';					
						
					} 			
	
				}
				
				if ( RELATED_SHOW ) {
				
					echo '<section><div class="heading"><h2>More Live Cams</h2></div>';
	
					get_related( AFFID, TRACK, '', RELATED_CNT );
					
					echo '</section>';
				}					

			}	
			
		// Featured Cam
		
			function featured( $mode, $room ) {
			
				switch ( $mode ) {
					
					case signup: 	//signup mode
					
						switch ( $room ) {
							
							case personal:
								$go = 'Jrvi';
								break;
							case top:
								$go = 'NxHf';
								break;								
							case male:
								$go = 'SKWo';
								break;								
							case tranny:
								$go = 'JXvq';
								break;	
								
						}
						
						break;

					default: 		// revshare mode

						switch ( $room ) {
							
							case personal:
								$go = '9oGW';
								break;
							case top:
								$go = 'dTm0';
								break;								
							case male:
								$go = 'CoeM';
								break;								
							case tranny:
								$go = 'zoQq';
								break;	
								
						}					
						
						break;

				}			
			
				if ( $room == 'personal' )
					echo '<iframe src="http://chaturbate.com/affiliates/in/' . $go . '/' . AFFID . '/?track=' . TRACK . '&amp;room=' . USER . '&amp;bgcolor=transparent" height="528" width="850" ></iframe>';
				else
					echo '<iframe src="http://chaturbate.com/affiliates/in/' . $go . '/' . AFFID . '/?track=' . TRACK . '&amp;bgcolor=transparent" height="528" width="850" ></iframe>';
			
			}
				
			
		// Human Readable Time

			function ago( $secs ) {
			
				$second = 1;
				$minute = 60;
				$hour = 60*60;
				$day = 60*60*24;
				$week = 60*60*24*7;
				$month = 60*60*24*7*30;
				$year = 60*60*24*7*30*365;
				 
				if ($secs <= 0) { $output = "now";
				}elseif ($secs > $second && $secs < $minute) { $output = round($secs/$second)." second";
				}elseif ($secs >= $minute && $secs < $hour) { $output = round($secs/$minute)." minute";
				}elseif ($secs >= $hour && $secs < $day) { $output = round($secs/$hour)." hour";
				}elseif ($secs >= $day && $secs < $week) { $output = round($secs/$day)." day";
				}elseif ($secs >= $week && $secs < $month) { $output = round($secs/$week)." week";
				}elseif ($secs >= $month && $secs < $year) { $output = round($secs/$month)." month";
				}elseif ($secs >= $year && $secs < $year*10) { $output = round($secs/$year)." year";
				}else{ $output = " more than a decade ago"; }
				 
				if ($output <> "now"){
				$output = (substr($output,0,2)<>"1 ") ? $output."s" : $output;
				}
				return $output;
				
			}	
		
		
		// Function to Limit characters of string.

			function limit_chars( $string, $word_limit ) {
			 
				$string = preg_replace( "/&#?[a-z0-9]{2,8};/i", "", strip_tags( $string ) );
				$words 	= explode( ' ', $string );
				
				$new_string = substr( $string, 0, $word_limit );
				
				return $new_string;
			 
			}

		// Paginate
		
			function paginate($page, $total_pages, $limit, $targetpage) { 
			
				// How many adjacent pages should be shown on each side?
				$adjacents = 3;
			
				// Setup page vars for display. 
				if ($page == 0) $page = 1;								//if no page var is given, default to 1.
				$prev = $page - 1;										//previous page is page - 1
				$next = $page + 1;										//next page is page + 1
				$lastpage = ceil($total_pages/$limit);					//lastpage is = total pages / items per page, rounded up.
				$lpm1 = $lastpage - 1;									//last page minus 1
				
				$targetpage = BASEHREF . $targetpage;
				
				// Now we apply our rules and draw the pagination object. We're actually saving the code to a variable in case we want to draw it more than once.
				$pagination = "";
				if ($lastpage > 1)
				{	
					$pagination .= '<div class="cb_pager">';
					//previous button
					if ($page > 1) 
						$pagination.= '<a href="' . $targetpage . $prev . '" class="prev button">previous</a>';
					else
						$pagination.= '<span class="disabled button">previous</span>';	
					
					//pages	
					if ($lastpage < 7 + ($adjacents * 2))	//not enough pages to bother breaking it up
					{	
						for ($counter = 1; $counter <= $lastpage; $counter++)
						{
							if ($counter == $page)
								$pagination.= '<span class="current button">' . $counter . '</span>';
							else
								$pagination.= '<a href="' . $targetpage . $counter . '" class="button">' . $counter . '</a>';					
						}
					}
					elseif($lastpage > 5 + ($adjacents * 2))	//enough pages to hide some
					{
						//close to beginning; only hide later pages
						if($page < 1 + ($adjacents * 2))		
						{
							for ($counter = 1; $counter < 4 + ($adjacents * 2); $counter++)
							{
								if ($counter == $page)
									$pagination.= '<span class="current button">' . $counter . '</span>';
								else
									$pagination.= '<a href="' . $targetpage . $counter . '" class="button">' . $counter . '</a>';					
							}
							$pagination.= '...';
							$pagination.= '<a href="' . $targetpage . $lpm1 . '" class="button">' . $lpm1 . '</a>';
							$pagination.= '<a href="' . $targetpage . $lastpage . '" class="button">' . $lastpage . '</a>';		
						}
						//in middle; hide some front and some back
						elseif($lastpage - ($adjacents * 2) > $page && $page > ($adjacents * 2))
						{
							$pagination.= '<a href="' . $targetpage . '/1" class="button">1</a>';
							$pagination.= '<a href="' . $targetpage . '/2" class="button">2</a>';
							$pagination.= '...';
							for ($counter = $page - $adjacents; $counter <= $page + $adjacents; $counter++)
							{
								if ($counter == $page)
									$pagination.= '<span class="current button">' . $counter . '</span>';
								else
									$pagination.= '<a href="' . $targetpage . $counter . '" class="button">' . $counter . '</a>';					
							}
							$pagination.= '...';
							$pagination.= '<a href="' . $targetpage . $lpm1 . '" class="button">' . $lpm1 . '</a>';
							$pagination.= '<a href="' . $targetpage . $lastpage . '" class="button">' . $lastpage . '</a>';		
						}
						//close to end; only hide early pages
						else
						{
							$pagination.= '<a href="' . $targetpage . '/1" class="button">1</a>';
							$pagination.= '<a href="' . $targetpage . '/2" class="button">2</a>';
							$pagination.= '...';
							for ($counter = $lastpage - (2 + ($adjacents * 2)); $counter <= $lastpage; $counter++)
							{
								if ($counter == $page)
									$pagination.= '<span class="current button">' . $counter . '</span>';
								else
									$pagination.= '<a href="' . $targetpage . $counter . '" class="button">' . $counter . '</a>';					
							}
						}
					}
				
					//next button
					if ($page <= $counter -1 ) 
						$pagination.= '<a href="' . $targetpage . $next . '" class="next button">next</a>';
					else
						$pagination.= '<span class="disabled button">next</span>';
					$pagination.= '</div>';		
				}
				
				echo $pagination;
				
			}			
	
	
?>